/*** Copyright (c), The Regents of the University of California            ***
 *** For more information please refer to files in the COPYRIGHT directory ***/
/* fileWrite.h - This file may be generated by a program or script
 */

#ifndef FILE_WRITE_H__
#define FILE_WRITE_H__

/* This is a low level file type API call */

#include "rcConnect.h"
#include "rodsDef.h"

typedef struct {
    int fileInx;
    int len;
} fileWriteInp_t;

#define fileWriteInp_PI "int fileInx; int len;"

#if defined(RODS_SERVER)
#define RS_FILE_WRITE rsFileWrite
#include "rodsConnect.h"
/* prototype for the server handler */
int
rsFileWrite( rsComm_t *rsComm, fileWriteInp_t *fileWriteInp,
             bytesBuf_t *fileWriteInpBBuf );
int
_rsFileWrite( rsComm_t *rsComm, fileWriteInp_t *fileWriteInp,
              bytesBuf_t *fileWriteInpBBuf );
int
remoteFileWrite( rsComm_t *rsComm, fileWriteInp_t *fileWriteInp,
                 bytesBuf_t *fileWriteInpBBuf, rodsServerHost_t *rodsServerHost );
#else
#define RS_FILE_WRITE NULL
#endif

/* prototype for the client call */
#ifdef __cplusplus
extern "C" {
#endif
int
rcFileWrite( rcComm_t *conn, fileWriteInp_t *fileWriteInp,
             bytesBuf_t *fileWriteInpBBuf );
#ifdef __cplusplus
}
#endif

#endif	// FILE_WRITE_H__
